//------------------------------------------------------------------------------
//
//  Escher Dices
//
//  Author: Bonsai (mail: bonsai@b0n541.net)
//
//  Copyright: GNU General Public License 
//
//------------------------------------------------------------------------------

#include "colors.inc"
#include "woods.inc"
#include "glass.inc"
#include "metals.inc"
#include "stones.inc"

background
        {
        color rgb <0, 0, 0>
        }

camera
        {
        location <100, 100, -100>
        look_at <0, 0, 0>
        angle 20
        aperture 10
        focal_point <4, 4, -4>
        blur_samples 1000
        }

light_source
        {
        <20, 60, -60>
        color rgb <1.5, 1.5, 1.5>
        spotlight 
        radius 15
        falloff 25
        tightness 0.5
        point_at <0, 0, 0>
        }

plane
        {
        <0, 1, 0>, -5
        
        texture
                {
                T_Wood8
                pigment
                        {
                        turbulence 0.1
                        //color rgb <1, 1, 1> 
                        }
                finish
                        {
                        ambient 0.3
                        reflection 0.2
                        }
                normal
                        {
                        wood
                        turbulence 0.04     
                        octaves 3
                        scale <0.05, .05, 10>
                        scale 20
                        rotate <5, 25, 0>
                        translate <5, 0 ,0>
                        }

                scale 20
                rotate <5, 25, 0>
                translate <5, 0 ,0>
                }
        }

// The object modelling
#declare Dice =
merge
        {
        box 
                {
                <-5, -5, -5>, <5, 5, 5>
                rotate <45, 0, 0>
                }

        box 
                {
                <-5, -5, -5>, <5, 5, 5>
                rotate <0, 45, 0>
                }

        box 
                {
                <-5, -5, -5>, <5, 5, 5>
                rotate <0, 0, 45>
                }
        }                

// All objects with textures
object
        {
        Dice
        rotate <0, -64, 0>

        texture
                {
                T_Stone41
                scale 20
                finish
                        {
                        reflection 0.2
                        }
                }
        }

object
        {
        Dice
        translate <-20, 0, 0>

        texture
                {
                T_Stone43
                scale 20
                finish
                        {
                        reflection 0.2
                        }
                }
        }

object
        {
        Dice
        rotate <0, 23, 0>
        translate <-15, 0, 20>

        texture
                {
                T_Stone38
                scale 40
                finish
                        {
                        reflection 0.1
                        }
                }
        }

object
        {
        Dice
        rotate <0, 180, 0>
        translate <10, 0, 25>

        texture
                {
                T_Stone37
                scale 20
                finish
                        {
                        //reflection 0.5
                        phong 1
                        phong_size 50
                        }
                }
        }

object
        {
        Dice
        rotate <0, 12, 0>
        translate <20, 0, -10>

        texture
                {
                T_Wood5
                scale 20
                }
        }

object
        {
        Dice
        rotate <0, -98, 0>
        translate <-15, 0, -20>

        texture
                {
                T_Wood33
                scale 40
                }
        }
